fixes and some improvements
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 export LESS=RXij12
228 export SYSTEMD_LESS=$LESS
229
230 export NNN_COLORS=2136
231
232 export SL_FILES_DIR=/b/ds/sl/.iank
233 export SL_INFO_DIR=/p/sshinfo
234
235
236 # * include files
237
238 if [[ -s $bashrc_dir/path-add-function ]]; then
239 source $bashrc_dir/path-add-function
240 if [[ $SSH_CLIENT ]]; then
241 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
242 export EMACSDIR=/home/iank/.iank/e/e
243 fi
244 path-add $bashrc_dir
245 fi
246 fi
247
248 # if someone exported $SOE (stop on error), catch errors.
249 #
250 # Note, on debian this results in the following warning when in ssh,
251 # hich I haven't figured out how to fix. It doesn't happen if we source
252 # after the shell has started
253 #
254 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
255 # bash: warning: cannot start debugger; debugging mode disabled
256 if [[ $SOE ]]; then
257 if [[ -e /a/bin/errhandle/err ]]; then
258 source /a/bin/errhandle/err
259 fi
260 fi
261
262
263 mysrc() {
264 local path dir file
265 path=$1
266 dir=${path%/*}
267 file=${path##*/}
268 if [[ -s $path ]]; then
269 source $path
270 elif [[ -s $bashrc_dir/$file ]]; then
271 source $bashrc_dir/$file
272 fi
273 }
274
275
276 mysrc /a/bin/small-misc-bash/ll-function
277 mysrc /a/bin/distro-functions/src/package-manager-abstractions
278
279
280 # * functions
281
282 ### begin FSF section ###
283
284 # Comments before functions are meant to be good useful
285 # documentation. If they fail at that, please improve them or send Ian a
286 # note.
287
288 ## copy bash completion
289 # Usage: ORIGINAL_COMMAND TARGET_COMMAND...
290 #
291 # It copies how the bash completion works from one command to other
292 # commands.
293 ccomp() {
294 local c src
295 src=$1
296 shift
297 if ! c=$(complete -p $src 2>/dev/null); then
298 _completion_loader $src &>/dev/null ||:
299 c=$(complete -p $src 2>/dev/null) || return 0
300 fi
301 # remove $src( .*|$)
302 c=${c% $src}
303 c=${c%% $src *}
304 eval $c $*
305 }
306
307 ## directory history tracking and navigation.
308 #
309 # cd becomes a function, also aliased to c. b to go back, f to go
310 # forward, cl to list recent directories and choose one.
311 #
312 # The finer details you may want to skip:
313 #
314 # We also define bl to print the list of back and forward directories.
315 #
316 # We keep 2 stacks, forward and back. Unlike with a web browser, the
317 # forward stack is not erased when going somewhere new.
318 #
319 # Recent directories are stored in ~/.cdirs.
320 #
321 declare -a _dir_forward _dir_back
322 c() {
323 # normally, the top of _dir_back is our current dir. if it isn't,
324 # put it on there, except we don't want to do that when we
325 # just launched a shell
326 if [[ $OLDPWD ]]; then
327 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
328 _dir_back+=("$PWD")
329 fi
330 fi
331 command cd "$@"
332 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
333 _dir_back+=("$PWD")
334 fi
335 echo "$PWD" >> ~/.cdirs
336 }
337 ccomp cd c
338
339 # back
340 b() {
341 local top_back
342 if (( ${#_dir_back[@]} == 0 )); then
343 echo "nothing left to go back to" >&2
344 return 0
345 fi
346 top_back="${_dir_back[-1]}"
347
348 if [[ $top_back == "$PWD" ]] && (( ${#_dir_back[@]} == 1 )); then
349 echo "already on last back entry" >&2
350 return 0
351 fi
352
353
354 if [[ $top_back == "$PWD" ]]; then
355 # add to dirf if not already there
356 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$top_back" ]]; then
357 _dir_forward+=("$top_back")
358 fi
359 unset "_dir_back[-1]"
360 command cd "${_dir_back[-1]}"
361 else
362 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$PWD" ]]; then
363 _dir_forward+=("$PWD")
364 fi
365 command cd "$top_back"
366 fi
367
368 # Interesting feature, not sure I want it.
369 # give us a peek at what is next in the list
370 # if (( ${#_dir_back[@]} >= 2 )); then
371 # printf "%s\n" "${_dir_back[-2]}"
372 # fi
373 #
374
375 # c/b/f Implementation notes:
376 #
377 # The top of the back is $PWD
378 # as long as the last directory change was due to c,b,or cl.
379 #
380 # Example of stack changes:
381 #
382 # a b c (d)
383 ## back
384 # a b (c)
385 # d
386 #back
387 #a (b)
388 #d c
389 #back
390 #(a)
391 #d c b
392 #forward
393 #a (b)
394 #d c
395 #
396 # a b c
397 ## back
398 # a b
399 # (c)
400 ## forward
401
402 }
403 # forward
404 f() {
405 local top_forward
406 if (( ${#_dir_forward[@]} == 0 )); then
407 echo "no forward dir left" >&2
408 return 0
409 fi
410 top_forward="${_dir_forward[-1]}"
411 unset "_dir_forward[-1]"
412 c "$top_forward"
413
414 # give us a peek at what is next in the list
415 # if (( ${#_dir_forward[@]} )); then
416 # printf "%s\n" "${_dir_forward[-1]}"
417 # fi
418 }
419 # cd list
420 cl() {
421 local i line input start
422 local -A buttondirs alines
423 local -a buttons dirs lines
424 buttons=( {a..z} {2..9} )
425 if [[ ! -s ~/.cdirs ]]; then
426 echo nothing in ~/.cdirs
427 return 0
428 fi
429
430 i=0
431
432 mapfile -t lines <~/.cdirs
433 start=$(( ${#lines[@]} - 1 ))
434
435 # we have ~33 buttons as of this writing, so lets
436 # prune down the history every once in a while.
437 if (( start > 500 )); then
438 tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | sponge ~/.cdirs
439 fi
440
441 for (( j=$start; j >= 0; j-- )); do
442 line="${lines[$j]}"
443 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
444 continue
445 fi
446 alines[$line]=t
447 buttondirs[${buttons[i]}]="$line"
448 printf "%s %s\n" ${buttons[i]} "$line"
449 if (( i == ${#buttons[@]} - 1 )); then
450 break
451 fi
452 i=$(( i + 1 ))
453 done
454
455 if (( i == 0 )); then
456 echo "no dirs in ~/.cdirs"
457 return 0
458 fi
459 read -r -N 1 input
460 if [[ $input != $'\n' ]]; then
461 c ${buttondirs[$input]}
462 fi
463 }
464 # back list
465 bl() {
466 local start i j max
467 max=10
468 start=$(( ${#_dir_back[@]} - 1 ))
469
470 # cleanup possible repeating of pwd
471 if (( start >= 0 )) && [[ ${_dir_back[$start]} == "$PWD" ]]; then
472 start=$(( start - 1 ))
473 fi
474 j=1
475 if (( start >= 0 )); then
476 for (( i=$start; i >= 0 ; i-- )); do
477 printf "%s %s\n" $j ${_dir_back[i]}
478 j=$(( j + 1 ))
479 if (( j >= max )); then
480 break
481 fi
482 done
483 fi
484
485 max=10
486 start=$(( ${#_dir_forward[@]} - 1 ))
487
488 # cleanup possible repeating of pwd
489 if (( start >= 0 )) && [[ ${_dir_forward[$start]} == "$PWD" ]]; then
490 start=$(( start - 1 ))
491 fi
492 if (( start < 0 )); then
493 return 0
494 fi
495 echo --
496 j=1
497 for (( i=$start; i >= 0 ; i-- )); do
498 printf "%s %s\n" $j ${_dir_forward[i]}
499 j=$(( j + 1 ))
500 if (( j >= max )); then
501 break
502 fi
503 done
504 }
505
506 # pee do. run args as a command with output copied to syslog.
507 #
508 # Usage: pd [-t TAG] COMMAND...
509 #
510 # -t TAG Override the tag in the syslog. The default is COMMAND with
511 # any path part is removed, eg. for /bin/cat the tag is cat.
512 #
513 # You can view the log via "journalctl -t TAG"
514 pd() {
515 local tag ret
516 ret=0
517 tag=${1##*/}
518 case $1 in
519 -t) tag="$2"; shift 2 ;;
520 esac
521 echo "PWD=$PWD command: $*" | logger -t $tag
522 "$@" |& pee cat "logger -t $tag" || ret=$?
523 echo "exited with status=$ret" | pee cat "logger -t $tag"
524 # this avoids any err-catch
525 (( $ret == 0 )) || return $ret
526 }
527 ccomp time pd
528
529 # jdo = journal do. Run command as transient systemd service, tailing
530 # its output in the journal until it completes.
531 #
532 # Usage: jdo COMMAND...
533 #
534 # Compared to pd: commands recognize this is a non-interactive shell.
535 # The service is unaffected if our ssh connection dies, no need to run
536 # in screen or tmux.
537 #
538 # Note: The last few lines of any existing entries for a unit by that
539 # name will be output first, and there will be a few second delay at the
540 # start of the command, and a second or so at the end.
541 #
542 # Note: Functions and aliases obviously won't work, we resolve the
543 # command to a file.
544 #
545 # Note: requires running as root.
546 jdo() {
547 local cmd cmd_name jr_pid ret
548 ret=0
549 cmd="$1"
550 shift
551 if [[ $EUID != 0 ]]; then
552 echo "jdo: error: rerun as root"
553 return 1
554 fi
555 cmd_name=${cmd##*/}
556 if [[ $cmd != /* ]]; then
557 cmd=$(type -P "$cmd")
558 fi
559 # -q = quiet
560 journalctl -qn2 -f -u "$cmd_name" &
561 # Trial and error of time needed to avoid missing initial lines.
562 # .5 was not reliable. 1 was not reliable. 2 was not reliable
563 sleep 4
564 jr_pid=$!
565 systemd-run --unit "$cmd_name" --wait --collect "$cmd" "$@" || ret=$?
566 # The sleep lets the journal output its last line
567 # before the prompt comes up.
568 sleep .5
569 kill $jr_pid &>/dev/null ||:
570 unset jr_pid
571 fg &>/dev/null ||:
572 # this avoids any err-catch
573 (( $ret == 0 )) || return $ret
574 }
575 ccomp time jdo
576 #### end fsf section
577
578
579 ..() { c ..; }
580 ...() { c ../..; }
581 ....() { c ../../..; }
582 .....() { c ../../../..; }
583 ......() { c ../../../../..; }
584
585 chere() {
586 local f path
587 for f; do
588 path=$(readlink -e "$f")
589 echo "cat >$path <<'EOF'"
590 cat "$f"
591 echo EOF
592 done
593 }
594
595
596 # file cut copy and paste, like the text buffers :)
597 # I havnt tested these.
598 _fbufferinit() { # internal use
599 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
600 rm -rf "${my_f_tempdir:?}"/*
601 }
602 fcp() { # file cp
603 _fbufferinit
604 cp "$@" "$my_f_tempdir"/
605 }
606 fct() { # file cut
607 _fbufferinit
608 mv "$@" "$my_f_tempdir"/
609 }
610 fpst() { # file paste
611 [[ $2 ]] && { echo too many arguments; return 1; }
612 target=${1:-.}
613 cp "$my_f_tempdir"/* "$target"
614 }
615
616 _khfix_common() {
617 local host ip port file key
618 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
619 file=$(readlink -f ~/.ssh/known_hosts)
620 if [[ ! $ip ]]; then
621 echo "khfix: ssh failed"
622 return 1
623 fi
624 if [[ $port != 22 ]]; then
625 ip_entry="[$ip]:$port"
626 host_entry="[$host]:$port"
627 else
628 ip_entry=$ip
629 host_entry=$host
630 fi
631 tmpfile=$(mktemp)
632 if [[ $host != $ip ]]; then
633 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
634 if [[ $key ]]; then
635 grep -Fv "$key" "$file" | sponge "$file"
636 fi
637 fi
638 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
639 if [[ $key ]]; then
640 grep -Fv "$key" "$file" | sponge "$file"
641 fi
642 ll ~/.ssh/known_hosts
643 rootsshsync
644 }
645 khfix() { # known hosts fix
646 _khfix_common "$@" || return 1
647 ssh $1 :
648 }
649 khcopy() {
650 _khfix_common "$@"
651 ssh-copy-id $1
652 }
653
654 a() {
655 local x
656 x=$(readlink -nf "${1:-$PWD}")
657 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
658 echo -n "$x" | xclip -selection clipboard
659 echo -n "$x" | xclip
660 }
661
662 # a1 = awk {print $1}
663 for field in {1..20}; do
664 eval a$field"() { awk '{print \$$field}'; }"
665 done
666 # h1 = head -n1
667 for num in {1..9}; do
668 eval h$num"() { head -n$num; }"
669 done
670
671
672 hexipv4() {
673 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
674 }
675
676 vp9() {
677 local f out outdir in
678 outdir=vp9
679 case $1 in
680 --out)
681 outdir=$2
682 shift 2
683 ;;
684 esac
685 m mkdir -p $outdir
686 for f; do
687 out=$PWD/$outdir/$f
688 in=$PWD/$f
689 m cd $(mktemp -d)
690 pwd
691 m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
692 m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
693 cd -
694 done
695 }
696
697 utcl() { # utc 24 hour time to local hour 24 hour time
698 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
699 }
700
701 bwm() {
702 s bwm-ng -T avg -d
703 }
704
705
706 # for running in a fai rescue
707 kdrescue() {
708 d=vgata-Samsung_SSD_850_EVO_2TB_S2RLNX0J502123D
709 for f in $d vgata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V; do
710 cryptsetup luksOpen --key-file /p /dev/$f/root crypt-$f-root
711 cryptsetup luksOpen --key-file /p /dev/$f/o crypt-$f-o
712 done
713 mount -o subvol=root_trisquelaramo /dev/mapper/crypt-$d-root /mnt
714 mount -o subvol=a /dev/mapper/crypt-$d-root /mnt/a
715 mount -o subvol=o /dev/mapper/crypt-$d-o /mnt/o
716 mount -o subvol=boot_trisquelaramo /dev/sda2 /mnt/boot
717 cd /mnt
718 chrbind
719 }
720
721
722
723
724 c4() { c /var/log/exim4; }
725
726 caa() { git commit --amend --no-edit -a; }
727
728 cf() {
729 for f; do
730 hr
731 echo "$f"
732 hr
733 cat "$f"
734 done
735 }
736 caf() {
737 # shellcheck disable=SC2033
738 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
739 -o -name .hg -prune -o -name .editor-backups -prune \
740 -o -name .undo-tree-history -prune \) \
741 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
742
743 }
744 ccomp cat cf caf
745
746 calc() { echo "scale=3; $*" | bc -l; }
747 # no having to type quotes, but also no command history:
748 clc() {
749 local x
750 read -r x
751 echo "scale=3; $x" | bc -l
752 }
753
754 cam() {
755 git commit -am "$*"
756 }
757
758 ccat () { # config cat. see a config without extra lines.
759 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
760 }
761 ccomp grep ccat
762
763 chrbind() {
764 local d
765 # dev/pts needed for pacman signature check
766 for d in dev proc sys dev/pts; do
767 [[ -d $d ]]
768 if ! mountpoint $d &>/dev/null; then
769 m s mount -o bind /$d $d
770 fi
771 done
772 }
773 chumount() {
774 local d
775 # dev/pts needed for pacman signature check
776 for d in dev/pts dev proc sys; do
777 [[ -d $d ]]
778 if mountpoint $d &>/dev/null; then
779 m s umount $d
780 fi
781 done
782 }
783
784
785 _cdiff-prep() {
786 # join options which are continued to multiples lines onto one line
787 local first=true
788 while IFS= read -r line; do
789 # remove leading spaces/tabs. assumes extglob
790 if [[ $line == "[ ]*" ]]; then
791 line="${line##+( )}"
792 fi
793 if $first; then
794 pastline="$line"
795 first=false
796 elif [[ $line == *=* ]]; then
797 echo "$pastline" >> "$2"
798 pastline="$line"
799 else
800 pastline="$pastline $line"
801 fi
802 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
803 echo "$pastline" >> "$2"
804 }
805
806 cdiff() {
807 # diff config files,
808 # setup for format of postfix, eg:
809 # option = stuff[,]
810 # [more stuff]
811 local pastline unified f1 f2
812 unified="$(mktemp)"
813 f1="$(mktemp)"
814 f2="$(mktemp)"
815 _cdiff-prep "$1" "$f1"
816 _cdiff-prep "$2" "$f2"
817 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
818 while IFS= read -r line; do
819 # the default bright red / blue doesnt work in emacs shell
820 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
821 done < "$unified"
822 }
823
824
825 cat-new-files() {
826 local start=$SECONDS
827 local dir="$1"
828 # shellcheck disable=SC2030
829 inotifywait -m "$dir" -e create -e moved_to | \
830 while read -r filedir _ file; do
831 cat "$filedir$file"
832 hr
833 calc $((SECONDS - start)) / 60
834 sleep 5
835 done
836
837 }
838
839 # shellcheck disable=SC2032
840 chown() {
841 # makes it so chown -R symlink affects the symlink and its target.
842 if [[ $1 == -R ]]; then
843 shift
844 command chown -h "$@"
845 command chown -R "$@"
846 else
847 command chown "$@"
848 fi
849 }
850
851 cim() {
852 git commit -m "$*"
853 }
854
855
856 d() { builtin bg "$@"; }
857 ccomp bg d
858
859 dc() {
860 diff --strip-trailing-cr -w "$@" # diff content
861 }
862 ccomp diff dc
863
864 despace() {
865 local x y
866 for x in "$@"; do
867 y="${x// /_}"
868 safe_rename "$x" "$y"
869 done
870 }
871
872 # get ipv4 ip from HOST. or if it is already a number, return that
873 hostip() {
874 local host="$1"
875 case $host in
876 [0-9:])
877 echo "$host"
878 ;;
879 *)
880 getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1
881 ;;
882 esac
883 }
884
885 dig() {
886 command dig +nostats +nocmd "$@"
887 }
888 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
889 digsort() {
890 local sec
891 sec=
892 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
893 if [[ $l == [^\;]* ]]; then
894 sec+="$l"$'\n'
895 else
896 if [[ $sec ]]; then
897 printf "%s" "$sec" | sort
898 sec=
899 fi
900 printf "%s\n" "$l"
901 fi
902 done
903 }
904 ccomp dig digsort
905 # compare digs to the 2 servers
906 # usage: digdiff @server1 @server2 DIG_ARGS
907 # note: only the soa master nameserver will respond with
908 # ra "recursive answer" flag. That difference is meaningless afaik.
909 digdiff() {
910 local s1 s2
911 s1=$1
912 shift
913 s2=$1
914 shift
915 digsort $s1 "$@" | tee /tmp/digdiff
916 diff -u /tmp/digdiff <(digsort $s2 "$@")
917 }
918
919 dt() {
920 date "+%A, %B %d, %r" "$@"
921 }
922 dtr() {
923 date -R "$@"
924 }
925 ccomp date dt dtr
926
927 dus() { # du, sorted, default arg of
928 du -sh ${@:-*} | sort -h
929 }
930 ccomp du dus
931
932
933 e() { printf "%s\n" "$*"; }
934
935 # echo args
936 ea() {
937 if (( ! $# )); then
938 echo no args
939 fi
940 for arg; do
941 printf "%qEOL\n" "${arg}"
942 printf "%s" "${arg}" |& hexdump -C
943 done
944 }
945 # echo vars. print var including escapes, etc
946 ev() {
947 if (( ! $# )); then
948 echo no args
949 fi
950 for arg; do
951 if [[ -v $arg ]]; then
952 printf "%qEOL\n" "${!arg}"
953 printf "%s" "${!arg}" |& hexdump -C
954 else
955 echo arg $arg is unset
956 fi
957 done
958 }
959
960 ediff() {
961 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
962 emacs --eval "(ediff-files \"$1\" \"$2\")"
963 }
964
965 # mail related
966 etail() {
967 ngset
968 tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
969 ngreset
970 }
971 etailm() {
972 tail -F /var/log/exim4/mainlog -n 200 "$@"
973 }
974 etail2() {
975 tail -F /var/log/exim4/mymain -n 200 "$@"
976 }
977 ccomp tail etail etail2
978
979
980
981
982 # print exim old pids
983 eoldpids() {
984 local configtime pid piduptime now daemonpid
985 printf -v now '%(%s)T' -1
986 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
987 if [[ -s /run/exim4/exim.pid ]]; then
988 daemonpid=$(cat /run/exim4/exim.pid)
989 fi
990 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
991 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
992 if [[ $pid == $daemonpid ]]; then
993 continue
994 fi
995 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
996 if (( configtime > now - piduptime )); then
997 echo $pid
998 fi
999 done
1000 }
1001
1002 # exim tail but only watch lines from new pids
1003 etailnew() {
1004 local pid oldpids
1005 for pid in $(eoldpids); do
1006 oldpids+="$pid|"
1007 done
1008 if [[ $oldpids ]]; then
1009 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
1010 else
1011 etail
1012 fi
1013 }
1014 # exim watch as old pids go away
1015 ewatchold() {
1016 local configtime pid piduptime now
1017 local -i count
1018 local -a oldpids
1019 count=0
1020 while true; do
1021 oldpids=($(eoldpids))
1022 if (( ! ${#oldpids[@]} )); then
1023 return
1024 fi
1025 # print the date every 20 iterations
1026 if (( ! count % 20 )); then
1027 date
1028 fi
1029 count+=1
1030 ps -f -p "${oldpids[*]}"
1031 sleep 1
1032 done
1033 }
1034
1035 eless() {
1036 less /var/log/exim4/mainlog
1037 }
1038 ccomp less eless
1039 eqcat() {
1040 exiqgrep -ir.\* -o 60 | while read -r i; do
1041 hlm exim -Mvc $i
1042 echo
1043 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
1044 done
1045 }
1046 eqrmf() {
1047 # other ways to get the list of message ids:
1048 # exim -bp | awk 'NF == 4 {print $3}'
1049 # # this is slower 160ms, vs 60.
1050 # exipick -i
1051 exiqgrep -ir.\* | xargs exim -Mrm
1052 }
1053
1054 econfdevnew() {
1055 rm -rf /tmp/edev
1056 mkdir -p /tmp/edev/etc
1057 cp -ra /etc/exim4 /tmp/edev/etc
1058 cp -ra /etc/alias* /tmp/edev/etc
1059 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
1060 econfdev
1061 }
1062 econfdev() {
1063 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
1064 }
1065
1066
1067
1068
1069 fa() {
1070 # find array. make an array of file names found by find into $x
1071 # argument: find arguments
1072 # return: find results in an array $x
1073 while read -rd ''; do
1074 x+=("$REPLY");
1075 done < <(find "$@" -print0);
1076 }
1077
1078 faf() { # find all files. use -L to follow symlinks
1079 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1080 -o -name .hg -prune -o -name .editor-backups -prune \
1081 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
1082 }
1083
1084 # full path without resolving symlinks
1085 fp() {
1086 local dir base
1087 base="${1##*/}"
1088 dir="${1%$base}"
1089 printf "%s/%s\n" $(cd $dir; pwd) "$base"
1090 }
1091
1092
1093 # mail related
1094 frozen() {
1095 rm -rf /tmp/frozen
1096 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
1097 sudo exim -Mvl $id
1098 echo
1099 sudo exim -Mvh $id
1100 echo
1101 sudo exim -Mvb $id
1102 echo -e '\n\n##############################\n'
1103 done | tee -a /tmp/frozen
1104 }
1105 frozenrm() {
1106 local ids=()
1107 while read -r line; do
1108 printf '%s\n' "$line"
1109 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
1110 done < <(s mailq)
1111 echo "sleeping for 2 in case you change your mind"
1112 sleep 2
1113 sudo exim -Mrm "${ids[@]}"
1114 }
1115
1116 funce() {
1117 # like -e for functions. returns on error.
1118 # at the end of the function, disable with:
1119 # trap ERR
1120 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
1121 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
1122 trap ERR
1123 return' ERR
1124 }
1125
1126 getdir () {
1127 local help="Usage: getdir [--help] PATH
1128 Output the directory of PATH, or just PATH if it is a directory."
1129 if [[ $1 == --help ]]; then
1130 echo "$help"
1131 return 0
1132 fi
1133 if [[ $# -ne 1 ]]; then
1134 echo "getdir error: expected 1 argument, got $#"
1135 return 1
1136 fi
1137 if [[ -d $1 ]]; then
1138 echo "$1"
1139 else
1140 local dir
1141 dir="$(dirname "$1")"
1142 if [[ -d $dir ]]; then
1143 echo "$dir"
1144 else
1145 echo "getdir error: directory does not exist"
1146 return 1
1147 fi
1148 fi
1149 }
1150
1151 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1152 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1153 local root
1154 root=$(gitroot) || return 1 # function to set gitroot
1155 builtin cd "$root"
1156 git symbolic-ref HEAD refs/heads/$1
1157 rm .git/index
1158 git clean -fdx
1159 }
1160
1161 # shellcheck disable=SC2120
1162 gitroot() {
1163 local help="Usage: gitroot [--help]
1164 Print the full path to the root of the current git repo
1165
1166 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1167 and works in older versions of git which did not have that."
1168 if [[ $1 == --help ]]; then
1169 echo "$help"
1170 return
1171 fi
1172 local p
1173 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1174 [[ $p != /* ]] && p=$PWD
1175 echo "${p%%/.git}"
1176 }
1177
1178 g() {
1179
1180 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1181 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1182
1183 local args gdb=false
1184
1185 if [[ $EMACSDIR ]]; then
1186 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1187 fi
1188
1189 if [[ $DISPLAY ]]; then
1190 args=-n
1191 fi
1192
1193 if (( $# == 0 )); then
1194 args+=" -c"
1195 fi
1196 # duplicate -c, but oh well
1197 if ! pgrep -u $EUID emacsclient; then
1198 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1199 gdb=true
1200 else
1201 args+=" -c"
1202 fi
1203 fi
1204 if [[ $EMACSDIR ]]; then
1205 # Alter the path here, otherwise the nfs mount gets triggered on the
1206 # first path lookup when emacs is not being used.
1207 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1208 else
1209 if $gdb; then
1210 # due to a bug, we cant debug from the start unless we get a new gdb
1211 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1212 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1213 m emacsclient -a "" $args "$@"
1214 sleep 1
1215 cd /a/opt/emacs-$(distro-name)$(distro-num)
1216 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
1217 cd -
1218 else
1219 m emacsclient -a "" $args "$@"
1220 fi
1221 fi
1222 }
1223
1224 # force terminal version
1225 gn() {
1226 g -n "$@"
1227 }
1228
1229 gmacs() {
1230 # quit will prompt if the program crashes.
1231 gdb -ex=r -ex=quit --args emacs "$@"; r;
1232 }
1233
1234 gdkill() {
1235 # kill the emacs daemon
1236 pk1 emacs --daemon
1237 }
1238
1239 gr() {
1240 grep -iIP --color=auto "$@" || return $?
1241 }
1242 grr() { # grep recursive
1243 # Don't return 1 on nonmatch because this is meant to be
1244 # interactive, not in a conditional.
1245 if [[ ${#@} == 1 ]]; then
1246 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1247 else
1248 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1249 fi
1250 }
1251 ccomp grep gr grr
1252
1253 rg() { grr "$@"; }
1254 ccomp grep rg
1255
1256 hr() { # horizontal row. used to break up output
1257 printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
1258 echo
1259 }
1260 # highlight
1261 hl() {
1262 local col input_len=0
1263 for arg; do
1264 input_len=$((input_len + 1 + ${#arg}))
1265 done
1266 col=$((60 - input_len))
1267 printf "\e[1;97;41m%s" "$*"
1268 if (( col > 0 )); then
1269 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1270 fi
1271 echo
1272 }
1273 hlm() { hl "$*"; "$@"; }
1274
1275 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1276
1277
1278 # get latest hub and run it
1279 # main command to use:
1280 # hub pull-request --no-edit
1281 # --no-edit means to use the first commit\'s message as the pull request message.
1282 # If that fails, try doing
1283 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1284 # where branch is usually master. it does the pr against your current branch.
1285 #
1286 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1287 # it\'s at ~/.config/hub
1288 hub() {
1289 local up uptar updir p v
1290 # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
1291 up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
1292 re='[[:space:]]'
1293 if [[ ! $up || $up == $re ]]; then
1294 echo "failed to get good update url. got: $up"
1295 fi
1296 uptar=${up##*/}
1297 updir=${uptar%.tgz}
1298 if [[ ! -e /a/opt/$updir ]]; then
1299 rm -rf /a/opt/hub-linux-amd64*
1300 wget -P /a/opt $up
1301 tar -C /a/opt -zxf /a/opt/$uptar
1302 rm -f /a/opt/$uptar
1303 fi
1304 if ! which hub &>/dev/null; then
1305 sudo /a/opt/$updir/install
1306 fi
1307
1308 # save token across computers
1309 if [[ ! -L ~/.config/hub ]]; then
1310 if [[ -e ~/.config/hub ]]; then
1311 mv ~/.config/hub /p/c/subdir_files/.config/
1312 fi
1313 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1314 conflink
1315 fi
1316 fi
1317 command hub "$@"
1318 }
1319
1320 i() { git "$@"; }
1321 ccomp git i
1322
1323 # git status:
1324 # cvs -qn update
1325
1326 # git checkout FILE
1327 # cvs update -C FILE
1328
1329 # git pull
1330 # cvs up[date]
1331
1332 # potentially useful command translation
1333 # https://fling.seas.upenn.edu/~giesen/dynamic/wordpress/equivalent-commands-for-git-svn-and-cvs/
1334
1335 # importing cvs repo into git using git-cvs package:
1336 # /f/www $ /usr/lib/git-core/git-cvsimport -C /f/www-git
1337
1338 ic() {
1339 # fast commit all
1340 git commit -am "$*"
1341 }
1342
1343 ipp() {
1344 git pull
1345 git push
1346 }
1347
1348
1349 ifn() {
1350 # insensitive find
1351 # -L = follow symlinks
1352 find -L . -not \( -name .svn -prune -o -name .git -prune \
1353 -o -name .hg -prune -o -name .editor-backups -prune \
1354 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1355 }
1356
1357 ifd() {
1358 # insensitive find directory
1359 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1360 -o -name .hg -prune -o -name .editor-backups -prune \
1361 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1362 }
1363
1364
1365 ipdrop() {
1366 sudo iptables -A INPUT -s $1 -j DROP
1367 }
1368
1369
1370 istext() {
1371 grep -Il "" "$@" &>/dev/null
1372 }
1373
1374 pst() {
1375 pstree -apnA
1376 }
1377
1378 jtail() {
1379 journalctl -n 10000 -f "$@"
1380 }
1381 jr() { journalctl "$@" ; }
1382 jrf() { journalctl -f "$@" ; }
1383 jru() {
1384 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1385 }
1386
1387
1388
1389 l() {
1390 if [[ $PWD == /[iap] ]]; then
1391 command ls -A --color=auto -I lost+found "$@"
1392 else
1393 command ls -A --color=auto "$@"
1394 fi
1395 }
1396
1397 lcn() { locate -i "*$**"; }
1398
1399 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1400
1401 lt() { ll -tr "$@"; }
1402
1403 lld() { ll -d "$@"; }
1404
1405 ccomp ls l lg lt lld ll
1406
1407 # low recursively
1408 lowr() {
1409 local f dirs i a
1410 local -a all
1411 for dirs in false true; do
1412 for f; do
1413 if [[ -d $f ]]; then
1414 all=("$f"/**)
1415 # reverse the order to rename the nested dirs first.
1416 # note: 0 element is the dir itself
1417 for ((i=${#all[@]}-1; i>=1; i--)); do
1418 a="${all[i]}"
1419 if $dirs && [[ -d $a ]]; then
1420 # e dirs low "$a" # debug
1421 low "$a"
1422 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1423 # debug
1424 # e not dirs low "$a" # debug
1425 low "$a"
1426 fi
1427 done
1428 fi
1429 # just rename all the top level args on the second pass
1430 if $dirs; then
1431 # e final dirs low "$f" # debug
1432 low "$f"
1433 fi
1434 done
1435 done
1436 }
1437
1438 low() { # make filenames lowercase, remove bad chars
1439 local arg new dir f
1440 for arg; do
1441 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1442 dir="${arg%/*}"
1443 if (( ${#dir} == ${#arg} )); then
1444 dir=.
1445 fi
1446 f="${arg##*/}"
1447 new="${f,,}" # downcase
1448 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1449 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1450 new="${new%"${new##*[[:alnum:]]}"}"
1451 # remove bad underscores, like __ and _._
1452 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1453 safe_rename "$dir/$f" "$dir/$new" || return 1
1454 done
1455 return 0
1456 }
1457
1458 lower() { # make first letter of filenames lowercase.
1459 local x
1460 for x in "$@"; do
1461 if [[ ${x::1} == [A-Z] ]]; then
1462 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1463 safe_rename "$x" "$y" || return 1
1464 fi
1465 done
1466 }
1467
1468
1469 k() { # history search
1470 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1471 }
1472 ks() { # history search with context
1473 # args are an extended regex used by sed
1474 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1475 }
1476 ksu() { # history search unique
1477 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1478 }
1479
1480 # todo: id like to do maybe a daily or hourly cronjob to
1481 # check that my history file size is increasing. Ive had it
1482 # inexplicably truncated in the past.
1483 histrm() {
1484 history -n
1485 HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1486 read -p "press anything but contrl-c to delete"
1487 for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1488 history -d $entry
1489 done
1490 history -w
1491 }
1492
1493 ccomp grep k ks ksu histrm
1494
1495
1496 make-targets() {
1497 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1498 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1499 }
1500
1501 mkc() {
1502 mkdir "$1"
1503 c "$1"
1504 }
1505 ccomp mkdir mkc
1506
1507 mkct() {
1508 mkc $(mktemp -d)
1509 }
1510
1511 mkt() { # mkdir and touch file
1512 local path="$1"
1513 mkdir -p "$(dirname "$path")"
1514 touch "$path"
1515 }
1516
1517 # shellcheck disable=SC2032
1518 mkdir() { command mkdir -p "$@"; }
1519
1520 nags() {
1521 # https://github.com/HenriWahl/Nagstamon/issues/357
1522 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1523 /usr/lib/notification-daemon/notification-daemon &
1524 fi
1525 /usr/bin/nagstamon &
1526 }
1527
1528 nmt() {
1529 # cant use s because sudo -i doesnt work for passwordless sudo command
1530 case $EUID in
1531 0)
1532 sudo nmtui-connect "$@"
1533 ;;
1534 *)
1535 nmtui-connect "$@"
1536 ;;
1537 esac
1538 }
1539
1540
1541 ngset() {
1542 if shopt nullglob >/dev/null; then
1543 ngreset=false
1544 else
1545 shopt -s nullglob
1546 ngreset=true
1547 fi
1548 }
1549 ngreset() {
1550 if $ngreset; then
1551 shopt -u nullglob
1552 fi
1553 }
1554
1555 nopanic() {
1556 # shellcheck disable=SC2024
1557 ngset
1558 for f in /var/log/exim4/paniclog /var/log/exim4/*panic; do
1559 base=${f##*/}
1560 if [[ -s $f ]]; then
1561 echo ================== $f =============
1562 s tee -a /var/log/exim4/$base-archive <$f
1563 s truncate -s0 $f
1564 fi
1565 done
1566 ngreset
1567 }
1568
1569
1570 ping() { command ping -O "$@"; }
1571 p8() { ping "$@" 8.8.8.8; }
1572 p6() { ping6 "$@" 2001:4860:4860::8888; }
1573
1574 pkx() { # package extract
1575 local pkg cached tmp f
1576 c $(mktemp -d)
1577 pkg=$1
1578 # shellcheck disable=SC2012
1579 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1580 if [[ $cached ]]; then
1581 cp $cached .
1582 else
1583 aptitude download $pkg || return 1
1584 fi
1585 tmp=(*); f=${tmp[0]} # only 1 expected
1586 ex $f
1587 rm -f $f
1588 }
1589
1590 # pgrep and kill
1591 pk1() {
1592 local pid
1593 pid=($(pgrep -f "$*"))
1594 case ${#pid[@]} in
1595 1)
1596 # shellcheck disable=SC2128
1597 {
1598 ps -F $pid
1599 m kill $pid
1600 }
1601 ;;
1602 0) echo "no pid found" ;;
1603 *)
1604 ps -F ${pid[@]}
1605 ;;
1606 esac
1607 }
1608
1609 psg () {
1610 local x y help
1611 help="Usage: psg [--help] GREP_ARGS
1612 grep ps and output in a nice format"
1613 if [[ $1 == --help ]]; then
1614 echo "$help"
1615 return
1616 fi
1617 x=$(ps -eF)
1618 # final grep is because some commands tend to have a lot of trailing spaces
1619 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1620 if [[ $y ]]; then
1621 echo "$x" | head -n 1 || [[ $? == 141 ]]
1622 echo "$y"
1623 fi
1624 }
1625
1626 pubip() { curl -4s https://icanhazip.com; }
1627 pubip6() { curl -6s https://icanhazip.com; }
1628 whatismyip() { pubip; }
1629
1630
1631 q() { # start / launch a program in the backround and redir output to null
1632 "$@" &> /dev/null &
1633 }
1634
1635 # shellcheck disable=SC2120
1636 r() {
1637 if [[ $HISTFILE ]]; then
1638 history -a # save history
1639 fi
1640 trap ERR # this avoids a segfault
1641 exit ${1:0}
1642 # i had this redir, not sure why
1643 # exit "$@" 2>/dev/null
1644 }
1645
1646 # scp is insecure and deprecated.
1647 scp() {
1648 rsync --inplace "$@"
1649 }
1650 ccomp rsync scp
1651
1652 randport() {
1653 # available high ports are 1024-65535,
1654 # but lets skip things that are more likely to be in use
1655 python3 <<'EOF'
1656 import secrets
1657 print(secrets.SystemRandom().randrange(10002,65500))
1658 EOF
1659 }
1660
1661 # reapply bashrc
1662 reb() {
1663 source ~/.bashrc
1664 }
1665
1666 rl() {
1667 readlink -f "$@"
1668 }
1669 ccomp readlink rl
1670
1671 rsd() {
1672 # rsync, root is required to keep permissions right.
1673 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1674 # --no-times --delete
1675 # basically, make an exact copy, use checksums instead of file times to be more accurate
1676 rsync -ahvic --delete "$@"
1677 }
1678 rsa() {
1679 # like rlu, but dont delete files on the target end which
1680 # do not exist on the original end.
1681 rsync -ahvic "$@"
1682 }
1683 rst() {
1684 # rl without preserving modification time.
1685 rsync -ahvic --delete --no-t "$@"
1686 }
1687 # [RSYNC_OPTS] HOST PATH
1688 rsu() {
1689 # eg. rsu -opts frodo /testpath
1690 # relative paths will expanded with readlink -f.
1691 opts=("${@:1:$#-2}") # 1 to last -2
1692 path="${*:$#}" # last
1693 host="${*:$#-1:1}" # last -1
1694 if [[ $path == .* ]]; then
1695 path=$(readlink -f $path)
1696 fi
1697 m rsync -ahvi --relative --no-implied-dirs "${opts[@]}" "$path" "root@$host:/";
1698 }
1699 ccomp rsync rsd rsa rst rsu
1700
1701 # find programs listening on a port
1702 ssp() {
1703 local port=$1
1704 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1705 s ss -lpn state listening sport = $port
1706 }
1707
1708 resolvcat() {
1709 local f
1710 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1711 m s nscd -i hosts
1712 fi
1713 f=/etc/resolv.conf
1714 echo $f:; ccat $f
1715 hr; s ss -lpn sport = 53
1716 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1717 # this will fail is dnsmasq is failed
1718 hr; m ser status dnsmasq | cat || :
1719 f=/etc/dnsmasq.conf
1720 hr; echo $f:; ccat $f
1721 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1722 f=/etc/dnsmasq-servers.conf
1723 hr; echo $f:; ccat $f
1724 fi
1725 hr
1726 echo /etc/nsswitch.conf:
1727 grep '^ *hosts:' /etc/nsswitch.conf
1728 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1729 hr; m ser status systemd-resolved | cat || :
1730 hr; m resolvectl status | cat
1731 fi
1732
1733 }
1734 rcat() {
1735 resolvcat | less
1736 }
1737 reresolv() {
1738 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1739 m ser stop nscd
1740 sleep .5
1741 m ser start nscd
1742 m sudo nscd -i hosts
1743 fi
1744 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1745 m sudo systemctl restart dnsmasq
1746 fi
1747 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1748 m sudo systemctl restart systemd-resolved
1749 fi
1750 if type -P resolvectl &>/dev/null; then
1751 resolvectl flush-caches
1752 fi
1753 }
1754
1755 rmstrips() {
1756 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1757 }
1758
1759 urun () {
1760 umask $1
1761 shift
1762 "$@"
1763 }
1764 sudo () {
1765 command sudo "$@" || return $?
1766 DID_SUDO=true
1767 }
1768 s() {
1769 # background
1770 # I use a function because otherwise we cant use in a script,
1771 # cant assign to variable.
1772 #
1773 # note: gksudo is recommended for X apps because it does not set the
1774 # home directory to the same, and thus apps writing to ~ fuck things up
1775 # with root owned files.
1776 #
1777 if [[ $EUID != 0 || $1 == -* ]]; then
1778 # shellcheck disable=SC2034
1779 SUDOD="$PWD" command sudo -i "$@"
1780 DID_SUDO=true
1781 else
1782 "$@"
1783 fi
1784 }
1785 sb() { # sudo bash -c
1786 # use sb instead of s is for sudo redirections,
1787 # eg. sb 'echo "ok fine" > /etc/file'
1788 # shellcheck disable=SC2034
1789 local SUDOD="$PWD"
1790 sudo -i bash -c "$@"
1791 }
1792 # secret sudo
1793 se() { s urun 0077 "$@"; }
1794 ccomp sudo s sb se
1795
1796 safe_rename() { # warn and dont rename if file exists.
1797 # mv -n exists, but it\'s silent
1798 if [[ $# != 2 ]]; then
1799 echo safe_rename error: $# args, need 2 >2
1800 return 1
1801 fi
1802 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1803 if [[ -e $2 || -L $2 ]]; then
1804 echo "Cannot rename $1 to $2 as it already exists."
1805 else
1806 mv -vi "$1" "$2"
1807 fi
1808 fi
1809 }
1810
1811
1812 sd() {
1813 sudo dd status=none of="$1"
1814 }
1815
1816 ser() {
1817 if type -p systemctl &>/dev/null; then
1818 s systemctl "$@"
1819 else
1820 if (( $# >= 3 )); then
1821 echo iank: ser expected 2 or less arguments
1822 return 1
1823 fi
1824 s service $2 $1
1825 fi
1826 }
1827 serstat() {
1828 systemctl -n 40 status "$@"
1829 }
1830
1831 seru() { systemctl --user "$@"; }
1832 # like restart, but do nothing if its not already started
1833 srestart() {
1834 local service=$1
1835 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1836 systemctl restart $service
1837 fi
1838 }
1839
1840 setini() { # set a value in a .ini style file
1841 key="$1" value="$2" section="$3" file="$4"
1842 if [[ -s $file ]]; then
1843 sed -ri -f - "$file" <<EOF
1844 # remove existing keys
1845 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1846 # add key
1847 /^\s*\[$section\]/a $key=$value
1848 # from section to eof, do nothing
1849 /^\s*\[$section\]/,\$b
1850 # on the last line, if we haven't found section yet, add section and key
1851 \$a [$section]\\
1852 $key=$value
1853 EOF
1854 else
1855 cat >"$file" <<EOF
1856 [$section]
1857 $key=$value
1858 EOF
1859 fi
1860 }
1861
1862 sgo() { # service go
1863 service=$1
1864 ser restart $service || return 1
1865 if type -p systemctl &>/dev/null; then
1866 ser enable $service
1867 fi
1868 }
1869 soff () {
1870 for service; do
1871 # ignore services that dont exist
1872 if systemctl cat $service &>/dev/null; then
1873 ser stop $service;
1874 ser disable $service
1875 fi
1876 done
1877 }
1878
1879 sgu() {
1880 systemctl list-unit-files | rg "$@"
1881 }
1882
1883
1884 sk() {
1885
1886
1887 # disable a warning with:
1888 # shellcheck disable=SC2206 # reasoning
1889
1890 # see bash-template/style-guide.md for justifications
1891
1892 local quotes others
1893 quotes=2048,2068,2086,2206
1894 others=2029,2033,2054,2164
1895 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
1896 }
1897
1898
1899 # sl: ssh, but firsh rsync our bashrc and related files to a special
1900 # directory on the remote host if needed.
1901
1902 # Some environment variables and files need to be setup for this to work
1903 # (mine are set at the beginning of this file)
1904
1905 # SL_FILES_DIR: Environment variable. Path to folder which should at
1906 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1907 # remote hosts (top level symlinks are resolved) unless the host already
1908 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1909 # control and sync files to separately and already has the ~/.bashrc you
1910 # want. The remote bash will also take its .inputrc config from this
1911 # folder (default of not existing is fine). Mine looks like this:
1912 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1913
1914 # SL_INFO_DIR: Environment variable. This folder stores info about what
1915 # we detected on the remote system and when we last synced. It will be created
1916 # if it does not exist. Sometimes you may want to forget about a
1917 # remote system, you can use sl --rsync, or the function for that slr
1918 # below.
1919
1920 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1921 # depending on the remote host. Run this string on the remote host the
1922 # first time sl is run (or if we run slr). The result is passed to
1923 # SL_TEST_HOOK. For example,
1924 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1925
1926 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1927 # $SL_FILES_DIR to vary the files synced.
1928
1929 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1930 # example to exclude files within a directory. Note, excluded
1931 # files wont be deleted on rsync, you can add --delete-excluded
1932 # to the rsync command if that is desired.
1933
1934 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1935
1936 # For when ~/.bashrc is already customized on the remote server, you
1937 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1938 # commands, even in scripts. This paragraph is all about that. bash
1939 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1940 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1941 # and if you customize it, probably has bugs from time to time. This is
1942 # bad. Here's how I fix it. I have a special condition to "return" in my
1943 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1944 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1945 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1946 # separate file because even if I return early on, the whole file gets
1947 # parsed which can fail if there is a syntax error.
1948 sl() {
1949 # Background on LC_USEBASHRC var (no need to read if you just want to
1950 # use this function): env variables sent across ssh are strictly
1951 # limited, but we get LC_* at least in debian based machines, so we
1952 # just make that * be something no normal program would use. Note, on
1953 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1954 # set, and the inner shell also allows running a nondefault
1955 # .bashrc. This means the outer shell still ran the default .bashrc,
1956 # but that is the best we can do.
1957
1958 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1959 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1960 declare -a args tmpa
1961
1962 args=($SL_SSH_ARGS)
1963
1964 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1965 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1966 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1967 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1968 # [command]
1969
1970 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
1971 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
1972 # [-F configfile] [-I pkcs11] [-i identity_file]
1973 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
1974 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
1975 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
1976
1977 force_rsync=false
1978 if [[ $1 == --rsync ]]; then
1979 force_rsync=true
1980 shift
1981 fi
1982
1983 sl_test_cmd=$SL_TEST_CMD
1984 sl_test_hook=$SL_TEST_HOOK
1985 sl_rsync_args=$SL_RSYNC_ARGS
1986 while [[ $1 ]]; do
1987 case "$1" in
1988 --rsync)
1989 force_rsync=true
1990 ;;
1991 --sl-test-cmd)
1992 sl_test_cmd="$2"
1993 shift
1994 ;;
1995 --sl-test-hook)
1996 sl_test_hook="$2"
1997 shift
1998 ;;
1999 --sl-rsync-args)
2000 sl_rsync_args="$2"
2001 shift
2002 ;;
2003 *)
2004 break
2005 ;;
2006 esac
2007 shift
2008 done
2009
2010 while [[ $1 ]]; do
2011 case "$1" in
2012 # note we dont support things like -4oOption
2013 -[46AaCfGgKkMNnqsTtVvXxYy]*)
2014 args+=("$1"); shift
2015 ;;
2016 -[bcDEeFIiJLlmOopQRSWw]*)
2017 # -oOption etc is valid
2018 if (( ${#1} >= 3 )); then
2019 args+=("$1"); shift
2020 else
2021 args+=("$1" "$2"); shift 2
2022 fi
2023 ;;
2024 *)
2025 break
2026 ;;
2027 esac
2028 done
2029 remote="$1"
2030 if [[ ! $remote ]]; then
2031 echo $0: error hostname required >&2
2032 return 1
2033 fi
2034 shift
2035
2036 if [[ ! $SL_INFO_DIR ]]; then
2037 echo error: missing '$SL_INFO_DIR' env var >&2
2038 return 1
2039 fi
2040
2041 dorsync=false
2042 haveinfo=false
2043 tmpa=($SL_INFO_DIR/???????????"$remote")
2044 sshinfo=${tmpa[0]}
2045 if [[ -e $sshinfo ]]; then
2046 if $force_rsync; then
2047 rm -f $sshinfo
2048 else
2049 haveinfo=true
2050 fi
2051 fi
2052 if $haveinfo; then
2053 tmp=${sshinfo[0]##*/}
2054 tmp2=${tmp::11}
2055 type=${tmp2: -1}
2056 extra_info=$(cat $sshinfo)
2057 else
2058 # we test for string to know ssh succeeded
2059 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
2060 testcmd="if $testbool; then printf y; else printf n; fi"
2061 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
2062 echo failed sl test. doing plain ssh -v
2063 command ssh -v "${args[@]}" "$remote"
2064 fi
2065 if [[ $tmp == y* ]]; then
2066 type=a
2067 else
2068 dorsync=true
2069 type=b
2070 fi
2071 extra_info="${tmp:1}"
2072 fi
2073 if [[ $sl_test_hook ]]; then
2074 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
2075 fi
2076
2077 if $haveinfo && [[ $type == b ]]; then
2078 info_sec=${tmp::10}
2079 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
2080 files_sec=${files_sec%%.*}
2081 if (( files_sec > info_sec )); then
2082 dorsync=true
2083 rm -f $sshinfo
2084 fi
2085 fi
2086
2087 sync_dirname=${SL_FILES_DIR##*/}
2088
2089 if [[ ! $SL_FILES_DIR ]]; then
2090 echo error: missing '$SL_FILES_DIR' env var >&2
2091 return 1
2092 fi
2093
2094 if $dorsync; then
2095 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
2096 fi
2097 if $dorsync || ! $haveinfo; then
2098 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
2099 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
2100 printf "%s\n" "$extra_info" >$sshinfo
2101 chmod 666 $sshinfo
2102 fi
2103 if [[ $type == b ]]; then
2104 if (( ${#@} )); then
2105 # Theres a couple ways to pass arguments, im not sure whats best,
2106 # but relying on bash 4.4+ escape quoting seems most reliable.
2107 command ssh "${args[@]}" "$remote" \
2108 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
2109 elif [[ ! -t 0 ]]; then
2110 # This case is when commands are being piped to ssh.
2111 # Normally, no bashrc gets sourced.
2112 # But, since we are doing all this, lets source it because we can.
2113 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2114 else
2115 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
2116 fi
2117 else
2118 if [[ -t 0 ]]; then
2119 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
2120 else
2121 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2122 fi
2123 fi
2124 # this function inspired from https://github.com/Russell91/sshrc
2125 }
2126
2127 slr() {
2128 sl --rsync "$@"
2129 }
2130 sss() { # ssh solo
2131 sl -oControlMaster=no -oControlPath=/ "$@"
2132 }
2133 # kill off old shared socket then ssh
2134 ssk() {
2135 m ssh -O exit "$@" || [[ $? == 255 ]]
2136 m sl "$@"
2137 }
2138 ccomp ssh sl slr sss ssk
2139 # plain ssh
2140 ssh() {
2141 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
2142 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
2143 else
2144 LC_USEBASHRC=t command ssh "$@"
2145 fi
2146 }
2147
2148
2149 slog() {
2150 # log with script. timing is $1.t and script is $1.s
2151 # -l to save to ~/typescripts/
2152 # -t to add a timestamp to the filenames
2153 local logdir do_stamp arg_base
2154 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
2155 logdir="/a/dt/"
2156 do_stamp=false
2157 while getopts "lt" option
2158 do
2159 case $option in
2160 l ) arg_base=$logdir ;;
2161 t ) do_stamp=true ;;
2162 esac
2163 done
2164 shift $((OPTIND - 1))
2165 arg_base+=$1
2166 [[ -e $logdir ]] || mkdir -p $logdir
2167 $do_stamp && arg_base+=$(date +%F.%T%z)
2168 script -t $arg_base.s 2> $arg_base.t
2169 }
2170 splay() { # script replay
2171 #logRoot="$HOME/typescripts/"
2172 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
2173 scriptreplay "$1.t" "$1.s"
2174 }
2175
2176 sr() {
2177 # sudo redo. be aware, this command may not work right on strange distros or earlier software
2178 if [[ $# == 0 ]]; then
2179 sudo -E bash -c -l "$(history -p '!!')"
2180 else
2181 echo this command redos last history item. no argument is accepted
2182 fi
2183 }
2184
2185 srm () {
2186 # with -ll, less secure but faster.
2187 command srm -ll "$@"
2188 }
2189
2190 srun() {
2191 scp $2 $1:/tmp
2192 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
2193 }
2194
2195
2196 swap() {
2197 local tmp
2198 tmp=$(mktemp)
2199 mv $1 $tmp
2200 mv $2 $1
2201 mv $tmp $2
2202 }
2203
2204 tclock() { # terminal clock
2205 local x
2206 clear
2207 date +%l:%_M
2208 len=60
2209 # this goes to full width
2210 #len=${1:-$((COLUMNS -7))}
2211 x=1
2212 while true; do
2213 if (( x == len )); then
2214 end=true
2215 d="$(date +%l:%_M) "
2216 else
2217 end=false
2218 d=$(date +%l:%M:%_S)
2219 fi
2220 echo -en "\r"
2221 echo -n "$d"
2222 for ((i=0; i<x; i++)); do
2223 if (( i % 6 )); then
2224 echo -n _
2225 else
2226 echo -n .
2227 fi
2228 done
2229 if $end; then
2230 echo
2231 x=1
2232 else
2233 x=$((x+1))
2234 fi
2235 sleep 5
2236 done
2237 }
2238
2239
2240 te() {
2241 # test existence / exists
2242 local ret=0
2243 for x in "$@"; do
2244 [[ -e "$x" || -L "$x" ]] || ret=1
2245 done
2246 return $ret
2247 }
2248
2249 psoff() {
2250 # normally, i would just execute these commands in the function.
2251 # however, DEBUG is not inherited, so we need to run it outside a function.
2252 # And we want to run set -x afterwards to avoid spam, so we cram everything
2253 # in here, and then it will run after this function is done.
2254 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
2255 }
2256 pson() {
2257 PROMPT_COMMAND=prompt-command
2258 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2259 trap 'settitle "$BASH_COMMAND"' DEBUG
2260 fi
2261 }
2262
2263 tx() { # toggle set -x, and the prompt so it doesnt spam
2264 if [[ $- == *x* ]]; then
2265 set +x
2266 pson
2267 else
2268 psoff
2269 fi
2270 }
2271
2272 psnetns() {
2273 # show all processes in the network namespace $1.
2274 # blank entries appear to be subprocesses/threads
2275 local x netns
2276 netns=$1
2277 ps -w | head -n 1
2278 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2279 while read -r l; do
2280 x=$(ps -w --no-headers -p $l);
2281 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2282 done
2283 }
2284 nonet() {
2285 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2286 s ip netns add nonet
2287 fi
2288 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2289 }
2290
2291 m() { printf "%s\n" "$*"; "$@"; }
2292
2293 # update file. note: duplicated in mail-setup
2294 u() {
2295 local tmp tmpdir dest="$1"
2296 local base="${dest##*/}"
2297 local dir="${dest%/*}"
2298 if [[ $dir != "$base" ]]; then
2299 # dest has a directory component
2300 mkdir -p "$dir"
2301 fi
2302 ur=false # u result
2303 tmpdir=$(mktemp -d)
2304 cat >$tmpdir/"$base"
2305 tmp=$(rsync -ic $tmpdir/"$base" "$dest")
2306 if [[ $tmp ]]; then
2307 printf "%s\n" "$tmp"
2308 ur=true
2309 if [[ $dest == /etc/systemd/system/* ]]; then
2310 reload=true
2311 fi
2312 fi
2313 rm -rf $tmpdir
2314 }
2315
2316
2317 uptime() {
2318 if type -p uprecords &>/dev/null; then
2319 uprecords -B
2320 else
2321 command uptime
2322 fi
2323 }
2324
2325 virshrm() {
2326 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2327 }
2328
2329 vm-set-listen(){
2330 local t
2331 t=$(mktemp)
2332 local vm=$1
2333 local ip=$2
2334 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2335 sed -r "s/listen='[^']+/listen='$ip/"> $t
2336 sudo virsh undefine $vm
2337 sudo virsh define $t
2338 }
2339
2340
2341 vmshare() {
2342 vm-set-listen $1 0.0.0.0
2343 }
2344
2345
2346 vmunshare() {
2347 vm-set-listen $1 127.0.0.1
2348 }
2349
2350 myiwscan() {
2351 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2352 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2353 sudo iw dev wls1 scan | sed -rn "
2354 s/^\Wcapability: (.*)/\1/;Ta;h;b
2355 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2356 # padded to min width of 20
2357 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2358 "|sort -r
2359 }
2360
2361 # Run script by copying it to a temporary location first,
2362 # and changing directory, so we don't have any open
2363 # directories or files that could cause problems when
2364 # remounting.
2365 z() {
2366 local tmp
2367 tmp=$(type -p "$1")
2368 if [[ $tmp ]]; then
2369 cd $(mktemp -d)
2370 cp -a "$tmp" .
2371 shift
2372 ./"${tmp##*/}" "$@"
2373 else
2374 "$@"
2375 fi
2376 }
2377
2378
2379 # * spark
2380 # spark 1 5 22 13 53
2381 # # => ▁▁▃▂▇
2382
2383 # The MIT License
2384 # Copyright (c) Zach Holman, https://zachholman.com
2385 # https://github.com/holman/spark
2386
2387 # As of 2022-10-28, I reviewed github forks that had several newer
2388 # commits, none had anything interesting. I did a little refactoring
2389 # mostly to fix emacs indent bug.
2390
2391 # Generates sparklines.
2392 _spark_echo()
2393 {
2394 if [ "X$1" = "X-n" ]; then
2395 shift
2396 printf "%s" "$*"
2397 else
2398 printf "%s\n" "$*"
2399 fi
2400 }
2401
2402
2403 spark()
2404 {
2405 local f tc
2406 local n numbers=
2407
2408 # find min/max values
2409 local min=0xffffffff max=0
2410
2411 for n in ${@//,/ }
2412 do
2413 # on Linux (or with bash4) we could use `printf %.0f $n` here to
2414 # round the number but that doesn't work on OS X (bash3) nor does
2415 # `awk '{printf "%.0f",$1}' <<< $n` work, so just cut it off
2416 n=${n%.*}
2417 (( n < min )) && min=$n
2418 (( n > max )) && max=$n
2419 numbers=$numbers${numbers:+ }$n
2420 done
2421
2422 # print ticks
2423 local ticks=(▁ ▂ ▃ ▄ ▅ ▆ ▇ █)
2424
2425 # use a high tick if data is constant
2426 (( min == max )) && ticks=(▅ ▆)
2427
2428 tc=${#ticks[@]}
2429 f=$(( ( (max-min) <<8)/( tc - 1) ))
2430 (( f < 1 )) && f=1
2431
2432 for n in $numbers
2433 do
2434 _spark_echo -n ${ticks[$(( ((($n-$min)<<8)/$f) ))]}
2435 done
2436 _spark_echo
2437 }
2438
2439
2440 # * misc stuff
2441
2442
2443 if $use_color && type -p tput &>/dev/null; then
2444 term_bold="$(tput bold)"
2445 term_red="$(tput setaf 1)"
2446 term_green="$(tput setaf 2)"
2447 term_yellow="$(tput setaf 3)"
2448 term_purple="$(tput setaf 5)"
2449 term_nocolor="$(tput sgr0)" # no font attributes
2450
2451 # unused so far. commented for shellcheck
2452 # term_underl="$(tput smul)"
2453 # term_blue="$(tput setaf 4)"
2454 # term_cyan="$(tput setaf 6)"
2455 fi
2456 # Try to keep environment pollution down, EPA loves us.
2457 unset safe_term match_lhs use_color
2458
2459 # * prompt
2460
2461
2462 if [[ $- == *i* ]]; then
2463
2464
2465 case $HOSTNAME in
2466 bk|je|li)
2467 if [[ $EUID == 1000 ]]; then
2468 system-status _ ||:
2469 fi
2470 ;;
2471 esac
2472
2473
2474 # this needs to come before next ps1 stuff
2475 # this stuff needs bash 4, feb 2009,
2476 # old enough to no longer condition on $BASH_VERSION anymore
2477 shopt -s autocd
2478 shopt -s dirspell
2479 PS1='\w'
2480 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2481 PROMPT_DIRTRIM=2
2482 bind -m vi-command B:shell-backward-word
2483 bind -m vi-command W:shell-forward-word
2484 fi
2485
2486 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2487 unset PROMPT_DIRTRIM
2488 PS1="\h:$PS1"
2489 fi
2490
2491 # emacs terminal has problems if this runs slowly,
2492 # so I've thrown a bunch of things at the wall to speed it up.
2493 prompt-command() {
2494 local return=$? # this MUST COME FIRST
2495 local ps_char ps_color
2496 unset IFS
2497
2498 if [[ $HISTFILE ]]; then
2499 history -a # save history
2500 fi
2501
2502 case $return in
2503 0) ps_color="$term_purple"
2504 ps_char='\$'
2505 ;;
2506 *) ps_color="$term_green"
2507 ps_char="$return \\$"
2508 ;;
2509 esac
2510 if [[ ! -O . ]]; then # not owner
2511 if [[ -w . ]]; then # writable
2512 ps_color="$term_bold$term_red"
2513 else
2514 ps_color="$term_bold$term_green"
2515 fi
2516 fi
2517
2518 # faster than sourceing the file im guessing
2519 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2520 eval $(< /dev/shm/iank-status)
2521 fi
2522 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2523 ps_char="@ $ps_char"
2524 fi
2525 # We could test if sudo is active with sudo -nv
2526 # but then we get an email and log of lots of failed sudo commands.
2527 # We could turn those off, but seems better not to.
2528 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2529 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2530 fi
2531 if [[ ! $HISTFILE ]]; then
2532 ps_char="NOHIST $ps_char"
2533 fi
2534 PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2535
2536 # set titlebar. instead, using more advanced
2537 # titelbar below
2538 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2539 }
2540 PROMPT_COMMAND=prompt-command
2541
2542 if [[ $TERM == screen* ]]; then
2543 _title_escape="\033]..2;"
2544 else
2545 # somme sites recommend this, i dunno what the diff is.
2546 #_title_escape="\033]30;"
2547 _title_escape="\033]0;"
2548 fi
2549
2550 settitle () {
2551 # this makes it so we show the current command if
2552 # one is running, otherwise, show nothing
2553
2554 if [[ $1 == prompt-command ]]; then
2555 return 0
2556 fi
2557 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2558 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2559 printf "%s" "$*"
2560 echo -ne "\007"
2561 fi
2562 }
2563
2564 # note, this wont work:
2565 # x=$(mktemp); cp a $x
2566 # I havnt figured out why, bigger fish to fry.
2567 #
2568 # for titlebar.
2569 # condition from the screen man page i think.
2570 # note: duplicated in tx()
2571 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2572 trap 'settitle "$BASH_COMMAND"' DEBUG
2573 else
2574 trap DEBUG
2575 fi
2576
2577 fi
2578
2579 # * stuff that makes sense to be at the end
2580
2581
2582 # best practice
2583 unset IFS
2584
2585 # shellcheck disable=SC1090
2586 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2587
2588 # I had this idea to start a bash shell which would run an initial
2589 # command passed through this env variable, then continue on
2590 # interactively. But the use case I had in mind went away.
2591 #
2592 # if [[ $MY_INIT_CMD ]]; then
2593 # "${MY_INIT_CMD[@]}"
2594 # unset MY_INIT_CMD
2595 # fi
2596
2597 # ensure no bad programs appending to this file will have an affect
2598 return 0